/* Developed for Lenovo Educational Board Pass 3
   © Lenovo Created by Joshua Grosser
   v. 2.0 */

// include Melopero library
#include "Melopero_APDS9960.h"
#include <Wire.h>
#include <SparkFun_APDS9960.h>

// create objects
SparkFun_APDS9960 apds = SparkFun_APDS9960();
Melopero_APDS9960 device;

void setup() {
  Serial.begin(9600); // set serial to 9600
  // set up the gesture sensor
  Wire.begin();
  device.initI2C(0x39, Wire);
  device.reset(); // Reset the device
  device.resetGestureEngineInterruptSettings();
  apds.init();
  Serial.println("Device initialized correctly!");

  // Gesture settings to set the distance for reading gestures
  device.enableGesturesEngine();
  device.setGestureProxEnterThreshold(25);
  device.setGestureExitThreshold(20);
  device.setGestureExitPersistence(EXIT_AFTER_4_GESTURE_END);

  // turn on gesture sensor
  device.wakeUp();
}

void loop() {
  // update the status to see if there is a gesture
  device.updateGestureStatus();
  // if gesture read the gesture
  if (device.gestureFifoHasData){
    device.parseGesture(300);

    if (device.parsedUpDownGesture != NO_GESTURE || device.parsedLeftRightGesture != NO_GESTURE)
        Serial.print("Gesture : ");

    if (device.parsedUpDownGesture == UP_GESTURE)
        Serial.print("UP ");
    else if (device.parsedUpDownGesture == DOWN_GESTURE)
        Serial.print("DOWN ");

    if (device.parsedLeftRightGesture == LEFT_GESTURE)
        Serial.print("LEFT ");
    else if (device.parsedLeftRightGesture == RIGHT_GESTURE)
        Serial.print("RIGHT ");

    if (device.parsedUpDownGesture != NO_GESTURE || device.parsedLeftRightGesture != NO_GESTURE)
        Serial.println();
  }
}
